{
  nodeName,
  repoFlake,
  nodeFlake,
  ...
}: let
  system = "aarch64-linux";
in {
  meta.nodeSpecialArgs.${nodeName} = {
    inherit repoFlake nodeName nodeFlake system;
    packages' = repoFlake.packages.${system};

    inherit
      (nodeFlake.inputs.bpir3.packages.${system})
      armTrustedFirmwareMT7986
      ;
  };

  meta.nodeNixpkgs.${nodeName} =
    import nodeFlake.inputs.nixpkgs.outPath
    {
      inherit system;
    };

  ${nodeName} = {
    deployment.targetHost = "router0.dmz0.noosphere.life";
    deployment.replaceUnknownProfiles = true;

    # nixpkgs.pkgs = nodeFlake.inputs.nixpkgs.legacyPackages.${system};

    imports = [
      nodeFlake.inputs.home-manager.nixosModules.home-manager

      ./configuration.nix
    ];

    networking.hostName = nodeName;
  };
}
