{...}: let
  stage1Modules = [
    "aesni_intel"
    "kvm_amd"
    "nvme"
    "nvme_core"

    "thunderbolt"
    "e1000e"
  ];
in {
  # TASK: new device
  hardware.opinionatedDisk = {
    enable = true;
    encrypted = true;
    diskId = "nvme-WD_BLACK_SN850X_4000GB_2227DT443901";
  };

  # see https://linrunner.de/tlp/
  services.tlp = {
    enable = true;
    settings = {
      # CPU_SCALING_GOVERNOR_ON_AC = "schedutil";
      CPU_SCALING_GOVERNOR_ON_BAT = "schedutil";

      # CPU_ENERGY_PERF_POLICY_ON_AC="balance_power";
      CPU_ENERGY_PERF_POLICY_ON_BAT="power";

      # SCHED_POWERSAVE_ON_AC="1";
      SCHED_POWERSAVE_ON_BAT="1";

      CPU_BOOST_ON_AC="0";
      CPU_BOOST_ON_BAT="0";

      # RADEON_DPM_PERF_LEVEL_ON_AC="auto";
      RADEON_DPM_PERF_LEVEL_ON_BAT="low";
      # RADEON_DPM_STATE_ON_AC="balanced";
      RADEON_DPM_STATE_ON_BAT="battery";

      # SOUND_POWER_SAVE_ON_AC="1";
      SOUND_POWER_SAVE_ON_BAT="1";

      # # PLATFORM_PROFILE_ON_AC="low-power";
      # # PLATFORM_PROFILE_ON_BAT="low-power";
      # PLATFORM_PROFILE_ON_AC="balanced";
      PLATFORM_PROFILE_ON_BAT="low-power";

      # RUNTIME_PM_ON_AC = "auto";
      RUNTIME_PM_ON_BAT = "auto";

      # PCIE_ASPM_ON_AC="default";
      PCIE_ASPM_ON_BAT="powersave";

      START_CHARGE_THRESH_BAT0 = "75";
      STOP_CHARGE_THRESH_BAT0 = "80";

      WOL_DISABLE="Y";
      # WIFI_PWR_ON_AC="on";
      WIFI_PWR_ON_BAT="on";
      DEVICES_TO_DISABLE_ON_STARTUP="wwan";
      # #DEVICES_TO_DISABLE_ON_LAN_CONNECT="wifi wwan";
      # #DEVICES_TO_DISABLE_ON_WIFI_CONNECT="wwan";
      # #DEVICES_TO_DISABLE_ON_WWAN_CONNECT="wifi";
    };
  };

  services.thinkfan = {
    enable = true;
    levels = [
      [0    0      55]
      [1    55     65]
      [1    65     75]
      [2    75     78]
      [3    78     80]
      [4    80     82]
      [5    82     84]
      [6    84     86]
      [7    86     88]
      ["level full-speed"    88     999]
    ];
  };


  # boot.initrd.availableKernelModules = stage1Modules;
  boot.initrd.kernelModules = stage1Modules;
}
